c     cont2dm - contour line generator 
c     
c     Ver.1.0 Thu May 11 22:40:11 JST 2000
c     Copyright Amane Tanaka (amane@bd5.so-net.ne.jp)
c
      program main
c
      include '../ng2d_par.f'
      dimension x(mx,my),y(mx,my),z(mx,my),msk(mx,my)
      dimension zc(100),dumm(100)
      character*80 ifile,ofile,fname
      character*256 dumstr
c
c     --- I/O uinit
      nd = 20
c
c     *** read information for input data file ***
      write(*,*) 'input filename?'
      read(*,'(A80)') ifile
      write(*,*) 'skip lines?'
      read(*,*) is
      write(*,*) 'nx ny?'
      read(*,*) nx,ny
      write(*,*) 'ix iy iz imsk iend?'
      read(*,*) ix,iy,iz,imsk,iend
c
c     *** read input data file ***
      open(nd,file=ifile,status='OLD')
c     --- skip lines     
      if (is.gt.0) then
         do 20 i=1,is
            read(nd,'(A80)') dumstr
 20      continue
      endif
c     --- read array data
      do 10 j=1,ny
         do 10 i=1,nx
            read(nd,*) (dumm(k),k=1,iend)
            x(i,j) = dumm(ix)
            y(i,j) = dumm(iy)
            z(i,j) = dumm(iz)
            if (imsk.ne.0) then
               msk(i,j)=int(dumm(imsk))
            else
               msk(i,j)=0
            endif
 10   continue
      close(nd)
c
c     *** check range of data ***
      call ngrngs(mx,my,z,zmin,imin,jmin,zmax,imax,jmax,
     &     1,1,nx,ny,msk)
c
c     *** read information for output data ***
      write(*,'(A7,1pe14.5,A10,1pe14.5)')
     &     'zmin = ',zmin,'   zmax = ',zmax
c
      write(*,*) 'output filename?'
      read(*,'(A80)') ofile
      write(*,*) 'number of contour levels?'
      read(*,*) nc
      do 30 i=1,nc
         write(*,'(a5,i4,a1)') 'level',i,'?'
         read(*,*) zc(i)
 30   continue
c
      fname = ofile(1:nglen(ofile)) // '_frm'
      call ngfrms(nd,fname,mx,my,x,y,1,1,nx,ny,msk)
      fname = ofile(1:nglen(ofile)) // '_grd'
      call ngrids(nd,fname,mx,my,x,y,1,1,nx,ny,msk)
      fname = ofile(1:nglen(ofile))
      call ngcm5s(nd,fname,mx,my,x,y,z,nc,zc,1,1,nx,ny,msk)
c
      stop
      end

